Index: django/test/_doctest.py
===================================================================
--- django/test/_doctest.py	(revision 10731)
+++ django/test/_doctest.py	(working copy)
@@ -1,5 +1,5 @@
 # This is a slightly modified version of the doctest.py that shipped with Python 2.4
-# It incorporates changes that have been submitted the the Python ticket tracker
+# It incorporates changes that have been submitted to the Python ticket tracker
 # as ticket #1521051. These changes allow for a DoctestRunner and Doctest base
 # class to be specified when constructing a DoctestSuite.
 
Index: django/core/files/uploadhandler.py
===================================================================
--- django/core/files/uploadhandler.py	(revision 10731)
+++ django/core/files/uploadhandler.py	(working copy)
@@ -152,7 +152,7 @@
         Use the content_length to signal whether or not this handler should be in use.
         """
         # Check the content-length header to see if we should
-        # If the the post is too large, we cannot use the Memory handler.
+        # If the post is too large, we cannot use the Memory handler.
         if content_length > settings.FILE_UPLOAD_MAX_MEMORY_SIZE:
             self.activated = False
         else:
Index: django/views/generic/create_update.py
===================================================================
--- django/views/generic/create_update.py	(revision 10731)
+++ django/views/generic/create_update.py	(working copy)
@@ -71,7 +71,7 @@
 def lookup_object(model, object_id, slug, slug_field):
     """
     Return the ``model`` object with the passed ``object_id``.  If
-    ``object_id`` is None, then return the the object whose ``slug_field``
+    ``object_id`` is None, then return the object whose ``slug_field``
     equals the passed ``slug``.  If ``slug`` and ``slug_field`` are not passed,
     then raise Http404 exception.
     """
Index: django/utils/feedgenerator.py
===================================================================
--- django/utils/feedgenerator.py	(revision 10731)
+++ django/utils/feedgenerator.py	(working copy)
@@ -121,7 +121,7 @@
 
     def add_root_elements(self, handler):
         """
-        Add elements in the the root (i.e. feed/channel) element. Called
+        Add elements in the root (i.e. feed/channel) element. Called
         from write().
         """
         pass
Index: django/contrib/gis/db/backend/spatialite/creation.py
===================================================================
--- django/contrib/gis/db/backend/spatialite/creation.py	(revision 10731)
+++ django/contrib/gis/db/backend/spatialite/creation.py	(working copy)
@@ -15,7 +15,7 @@
     if settings.DATABASE_ENGINE != 'sqlite3':
         raise Exception('SpatiaLite database creation only supported on sqlite3 platform.')
 
-    # Getting the test database name using the the SQLite backend's
+    # Getting the test database name using the SQLite backend's
     # `_create_test_db`.  Unless `TEST_DATABASE_NAME` is defined,
     # it returns ":memory:".
     db_name = connection.creation._create_test_db(verbosity, autoclobber)
Index: django/contrib/gis/measure.py
===================================================================
--- django/contrib/gis/measure.py	(revision 10731)
+++ django/contrib/gis/measure.py	(working copy)
@@ -41,7 +41,7 @@
 class MeasureBase(object):
     def default_units(self, kwargs):
         """
-        Return the unit value and the the default units specified
+        Return the unit value and the default units specified
         from the given keyword arguments dictionary.
         """
         val = 0.0
Index: django/contrib/gis/geos/libgeos.py
===================================================================
--- django/contrib/gis/geos/libgeos.py	(revision 10731)
+++ django/contrib/gis/geos/libgeos.py	(working copy)
@@ -30,7 +30,7 @@
 else:
     raise ImportError('Unsupported OS "%s"' % os.name)
 
-# Using the ctypes `find_library` utility to find the the path to the GEOS
+# Using the ctypes `find_library` utility to find the path to the GEOS
 # shared library.  This is better than manually specifiying each library name
 # and extension (e.g., libgeos_c.[so|so.1|dylib].).
 if lib_names:
Index: django/contrib/gis/templates/gis/admin/openlayers.html
===================================================================
--- django/contrib/gis/templates/gis/admin/openlayers.html	(revision 10731)
+++ django/contrib/gis/templates/gis/admin/openlayers.html	(working copy)
@@ -15,7 +15,7 @@
 </style>
 <!--[if IE]>
 <style type="text/css">
-  /* This fixes the the mouse offset issues in IE. */
+  /* This fixes the mouse offset issues in IE. */
   #{{ id }}_admin_map { position: static; vertical-align: top; }
   /* `font-size: 0` fixes the 1px border between tiles, but borks LayerSwitcher.
       Thus, this is disabled until a better fix is found.
Index: django/contrib/csrf/tests.py
===================================================================
--- django/contrib/csrf/tests.py	(revision 10731)
+++ django/contrib/csrf/tests.py	(working copy)
@@ -59,7 +59,7 @@
     # Check the post processing
     def test_process_response_no_session(self):
         """
-        Check the the post-processor does nothing if no session active
+        Check the post-processor does nothing if no session active
         """
         req = self._get_GET_no_session_request()
         resp = self._get_post_form_response()
Index: django/template/defaulttags.py
===================================================================
--- django/template/defaulttags.py	(revision 10731)
+++ django/template/defaulttags.py	(working copy)
@@ -1136,7 +1136,7 @@
 
         <img src='bar.gif' height='10' width='{% widthratio this_value max_value 100 %}' />
 
-    Above, if ``this_value`` is 175 and ``max_value`` is 200, the the image in
+    Above, if ``this_value`` is 175 and ``max_value`` is 200, the image in
     the above example will be 88 pixels wide (because 175/200 = .875;
     .875 * 100 = 87.5 which is rounded up to 88).
     """
Index: tests/modeltests/get_object_or_404/models.py
===================================================================
--- tests/modeltests/get_object_or_404/models.py	(revision 10731)
+++ tests/modeltests/get_object_or_404/models.py	(working copy)
@@ -55,7 +55,7 @@
 >>> get_object_or_404(Article, title__contains="Run")
 <Article: Run away!>
 
-# We can also use the the Article manager through an Author object.
+# We can also use the Article manager through an Author object.
 >>> get_object_or_404(a.article_set, title__contains="Run")
 <Article: Run away!>
 
Index: tests/regressiontests/templates/loaders.py
===================================================================
--- tests/regressiontests/templates/loaders.py	(revision 10731)
+++ tests/regressiontests/templates/loaders.py	(working copy)
@@ -45,7 +45,7 @@
     Creates a mock egg with a list of resources.
 
     name: The name of the module.
-    resources: A dictionary of resources. Keys are the names and values the the data.
+    resources: A dictionary of resources. Keys are the names and values the data.
     """
     egg = imp.new_module(name)
     egg.__loader__ = MockLoader()
Index: docs/internals/contributing.txt
===================================================================
--- docs/internals/contributing.txt	(revision 10731)
+++ docs/internals/contributing.txt	(working copy)
@@ -325,7 +325,7 @@
         tickets, we keep all the discussion in one place, which helps everyone.
 
     "worksforme"
-        Used when the the ticket doesn't contain enough detail to replicate
+        Used when the ticket doesn't contain enough detail to replicate
         the original bug.
 
 If you believe that the ticket was closed in error -- because you're
Index: docs/ref/contrib/admin/actions.txt
===================================================================
--- docs/ref/contrib/admin/actions.txt	(revision 10731)
+++ docs/ref/contrib/admin/actions.txt	(working copy)
@@ -187,7 +187,7 @@
 ---------------------------------------
 
 By default, after an action is performed the user is simply redirected back
-the the original change list page. However, some actions, especially more
+to the original change list page. However, some actions, especially more
 complex ones, will need to return intermediate pages. For example, the
 built-in delete action asks for confirmation before deleting the selected
 objects.
Index: docs/ref/authbackends.txt
===================================================================
--- docs/ref/authbackends.txt	(revision 10731)
+++ docs/ref/authbackends.txt	(working copy)
@@ -22,7 +22,7 @@
 .. class:: ModelBackend
 
     This is the default authentication backend used by Django.  It
-    authenticates using usernames and passwords stored in the the
+    authenticates using usernames and passwords stored in the
     :class:`~django.contrib.auth.models.User` model.
 
 